import React from "react";
import { Extension } from "@codemirror/state";
import { Diagnostic } from "@codemirror/lint";
import { ITableSchema } from "./utils";
import { CompletionsType, FunctionType, HintPathType, PlaceholderThemesType, ScriptEditorRef, variablesModel } from "./interface";
export interface ITextEditorProps {
    defaultValue?: string;
    showOutLine?: boolean;
    mode: "json" | "javascript" | "sql" | "html" | "customScript";
    placeholderThemes?: PlaceholderThemesType;
    placeholderThemeFiled?: string;
    onChange: (value: string, rely?: any) => void;
    onError?: (error: Diagnostic) => void;
    onFocusChange?: (focus: boolean) => void;
    trigger?: "blur" | "change";
    editable?: boolean;
    height?: number;
    minHeight?: number;
    placeholder?: string | HTMLElement;
    tables?: ITableSchema;
    keywords?: string[];
    keywordsClassName?: string;
    keywordsColor?: string;
    functions?: FunctionType[];
    extensions?: Extension[];
    variables?: variablesModel[];
    hintPaths?: HintPathType[];
    completions?: CompletionsType[];
    withSelect?: boolean;
    themeStyle?: {
        [K: string]: any;
    };
}
declare const _default: React.ForwardRefExoticComponent<ITextEditorProps & React.RefAttributes<ScriptEditorRef>>;
export default _default;
