/// <reference types="react" />
import { ITextEditorProps } from "./CodeEditor";
export interface CompletionsType {
    template: string;
    label: string;
    detail: string;
    type: string;
    parent?: any;
}
export interface FunctionType extends CompletionsType {
    handle?: any;
    returnType?: string;
    briefly?: string;
    paramNum?: number;
    example?: string;
    instruction?: string;
    children?: FunctionType[];
}
export interface HintPathType {
    label: string;
    detail: string;
    type: "function" | "keyword" | "variable" | "text" | "property";
    template: string;
    children?: HintPathType[];
}
export interface PlaceholderThemesType {
    [K: string]: CommonPlaceholderTheme;
}
export interface CommonPlaceholderTheme {
    textColor: string;
    backgroudColor: string;
}
export interface ScriptEditorRef {
    insertText: (text: string, isTemplate: boolean) => void;
    clearText: () => void;
    setText: (text: string) => void;
    getValue: () => string | any;
    hasFocus?: boolean;
    originEditorRef: any;
}
export interface IWithSelectCodemirrorRef {
}
export interface variablesModel {
    code: string;
    name: string;
    children?: variablesModel[];
    type: "model" | "field";
    value?: any;
    fieldType?: string;
}
export interface IParseFunctionResult {
    funIng: Function;
    func: Function;
    funcs: {
        [x: string]: any;
    };
    data: any;
    formatResult: string;
}
export interface IWithSelectCodemirrorProps extends ITextEditorProps {
    actionBoxHeight?: string;
    showHeader?: boolean;
    renderHeader?: React.ReactNode | string;
    customTool?: React.ReactNode | string;
    clickDebug?: (result: IParseFunctionResult) => void;
}
